From 4cca86c766f26717b0aa0f2c87810396e0f79a5d Mon Sep 17 00:00:00 2001
From: Alexey Min <alexey.min@gmail.com>
Date: Wed, 29 Jan 2020 19:53:39 +0300
Subject: [PATCH 04/59] AlpineApkBackend: some cleanup on updates checking
 functions

---
 .../AlpineApkBackend/AlpineApkBackend.cpp     | 41 ++++++++++++-------
 .../AlpineApkBackend/AlpineApkBackend.h       |  5 ++-
 2 files changed, 30 insertions(+), 16 deletions(-)

diff --git a/libdiscover/backends/AlpineApkBackend/AlpineApkBackend.cpp b/libdiscover/backends/AlpineApkBackend/AlpineApkBackend.cpp
index de93609ac..41b2e0532 100644
--- a/libdiscover/backends/AlpineApkBackend/AlpineApkBackend.cpp
+++ b/libdiscover/backends/AlpineApkBackend/AlpineApkBackend.cpp
@@ -55,8 +55,10 @@ AlpineApkBackend::AlpineApkBackend(QObject *parent)
 
     qCDebug(LOG_ALPINEAPK) << "constructing backend!";
 
-    QTimer::singleShot(500, this, &AlpineApkBackend::toggleFetching);
-    connect(m_updater, &StandardBackendUpdater::updatesCountChanged, this, &AlpineApkBackend::updatesCountChanged);
+    QTimer::singleShot(1000, this, &AlpineApkBackend::startCheckForUpdates);
+
+    QObject::connect(m_updater, &StandardBackendUpdater::updatesCountChanged,
+                     this, &AlpineApkBackend::updatesCountChanged);
 
     populate();
 
@@ -65,12 +67,14 @@ AlpineApkBackend::AlpineApkBackend(QObject *parent)
 
 QVector<Category *> AlpineApkBackend::category() const
 {
+    // single root category
+    // we could add more, but Alpine apk does not have this concept
     static Category *cat = new Category(
-                QStringLiteral("All applications"),    // displayName
-                QStringLiteral("applications-other"),  // icon
-                { }, // orFilters
+                QStringLiteral("All packages"),    // displayName
+                QStringLiteral("package-x-generic"), // icon
+                {}, // orFilters
                 { displayName() }, // pluginName
-                { }, // subCategories
+                {}, // subCategories
                 QUrl(), // decoration (what is it?)
                 false  // isAddons
     );
@@ -112,11 +116,23 @@ void AlpineApkBackend::populate()
     }
 }
 
-void AlpineApkBackend::toggleFetching()
+void AlpineApkBackend::startCheckForUpdates()
 {
-    m_fetching = !m_fetching;
+    if (m_fetching) {
+        return;
+    }
+    qCDebug(LOG_ALPINEAPK) << "startCheckForUpdates()";
+
+    m_fetching = true;
+    emit fetchingChanged();
+
+    // temporary hack - finish updates check in 5 seconds
+    QTimer::singleShot(5000, this, &AlpineApkBackend::finishCheckForUpdates);
+}
 
-    qCDebug(LOG_ALPINEAPK) << "fetching..." << m_fetching;
+void AlpineApkBackend::finishCheckForUpdates()
+{
+    m_fetching = false;
     emit fetchingChanged();
 }
 
@@ -212,14 +228,11 @@ Transaction* AlpineApkBackend::removeApplication(AbstractResource *app)
 
 void AlpineApkBackend::checkForUpdates()
 {
-    if(m_fetching) {
+    if (m_fetching) {
         qCDebug(LOG_ALPINEAPK) << "checkForUpdates(): already fetching";
         return;
     }
-    qCDebug(LOG_ALPINEAPK) << "checkForUpdates() start!";
-    toggleFetching();
-    // populate(QStringLiteral("Moar"));
-    QTimer::singleShot(1000, this, &AlpineApkBackend::toggleFetching);
+    startCheckForUpdates();
 }
 
 QString AlpineApkBackend::displayName() const
diff --git a/libdiscover/backends/AlpineApkBackend/AlpineApkBackend.h b/libdiscover/backends/AlpineApkBackend/AlpineApkBackend.h
index f8d3aa69f..68a47bc92 100644
--- a/libdiscover/backends/AlpineApkBackend/AlpineApkBackend.h
+++ b/libdiscover/backends/AlpineApkBackend/AlpineApkBackend.h
@@ -55,7 +55,8 @@ public:
     bool hasApplications() const override;
 
 public Q_SLOTS:
-    void toggleFetching();
+    void startCheckForUpdates();
+    void finishCheckForUpdates();
 
 private:
     void populate();
@@ -66,7 +67,7 @@ private:
     QtApk::Database m_apkdb;
     QVector<QtApk::Package> m_availablePackages;
     QVector<QtApk::Package> m_installedPackages;
-    bool m_fetching = true;
+    bool m_fetching = false;
     int m_startElements = 0;
 };
 
-- 
GitLab


